
import java.awt.Color;

/** The perception of a robot (an {@link OrientPoint oriented point} and 
 * a {@link java.awt.Color color}).
 *
 * @author  A. Scheuer, UL, FST, DI and LORIA.
 */
public class Detection {
	private OrientPoint config; 
	private Color       color;
	private boolean     leader;
	
	/** Main constructor, building a description from an oriented point,
	 * a color and a boolean.
	 * @param cfg    the oriented point of the description, 
	 * @param color  the color of the description, 
	 * @param ldr    whether the detected robot is a leader.
	 */
	public Detection(final OrientPoint cfg, final Color color, final boolean ldr)
	{ config = cfg; this.color = color; leader = ldr; }

	/** Description method, giving the oriented point of the description.
	 * @return  the oriented point of the description. */
	public final OrientPoint config() { return this.config; }

	/** Description method, giving the color of the description.
	 * @return  the color of the description. */
	public final Color       color()  { return this.color; }	
	
	/** Description method, giving whether the detected robot is a leader.
	 * @return  whether the detected robot is a leader or not. */
	public final boolean     leader()  { return this.leader; }	
} // end of class Detection
