
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import madkit.kernel.AbstractAgent;
import madkit.utils.graphics.SimpleGraphicSell;
import madkit.kernel.Kernel;


public class FindCoefs {
    // requis pour la sérialisation (!?!), 3* -> envirt
	public static final long serialVersionUID = 37L;
	
	private static class CoefAndRes {
		final double[] rCoefs; 
		public double  result;
		public CoefAndRes(final double[] coefs) { rCoefs = coefs; result = -1; }
		public final double[] coefs() { return rCoefs; }
	}

	private static class TestCoefs extends madkit.kernel.Agent {
	    // requis pour la sérialisation (!?!), 3* -> envirt
		public static final long serialVersionUID = 36L;
		
		List<AbstractAgent> agentsList;
		List<Robot>         robotsList;
		Scheduler           robotScheduler;
		Environment         robotEnvironment;
		CoefAndRes          test;
		public boolean      active;

		public TestCoefs(CoefAndRes data) { test = data; active = false;  }

		public void activate() {}

		public void start()
		{
			agentsList       = new ArrayList<AbstractAgent>();
			robotsList       = new ArrayList<Robot>();
			robotScheduler   = new Scheduler(1);
			agentsList.add(robotScheduler);
			robotEnvironment = new Environment(800, 600, 5000);
			agentsList.add(robotEnvironment);

			createGroup(true, "react", "robots", null, null);
			requestRole("react", "robots", "launcher", null);

			launchAgent(robotEnvironment, "robot world", false);
			launchAgent(robotScheduler, "robot scheduler", false);
			Robot.setCoefs( test.coefs() );
			active = true; 

			launchRobots(1, true);    // launch a leader
			launchRobots(14, false);  // & 14 followers
		}

		public void live() 
		{ while( robotEnvironment.testing() )  exitImmediatlyOnKill(); }

		public void end()
		{
			for(int iCoef = 0; iCoef < test.coefs().length; iCoef++) {
				System.out.print(iCoef == 0 ? "(" : ", "); 
				System.out.print(test.coefs()[iCoef]); 
			}
			System.out.print(") -> "); 
			test.result = robotEnvironment.testResult();
			System.out.println(test.result);
			killAgent(robotScheduler);
			killAgent(robotEnvironment);
			for (Iterator<AbstractAgent> i =agentsList.iterator(); i.hasNext();)
				killAgent( (AbstractAgent) i.next() );
			for (Iterator<Robot> i = robotsList.iterator(); i.hasNext();)
				killAgent( (Robot) i.next() );
			Kernel.debugString();
			System.gc();
			active = false; 
		}

		public void initGUI() {}
	
		public synchronized void launchRobots(int numberOfRobots, boolean isLeader)
		{
			int id = robotsList.size();
			for(int nb = 0; nb < numberOfRobots; nb++) {
				Robot robot = new Robot(id, isLeader);
				launchAgent(robot, isLeader ? "leader" : "robot", false);
				id++;
				robotsList.add(robot);
			}
		}
		
	}

	private static class GUI extends SimpleGraphicSell {
	    // requis pour la sérialisation (!?!), 1* -> GUI
		public static final long serialVersionUID = 14L;
		
		TestCoefs appli; 
		
		public GUI(CoefAndRes data) 
		{ super("Coefs Test"); appli = new TestCoefs(data); }

		public void start() { 
			_localKernel.launchAgent(appli, "robots", _localKernel, true); 
			appli.start();
		}
		
		public boolean alive() { return appli.active; }
		
	}

	public static double eval(final double[] coefs){ 
		CoefAndRes data = new CoefAndRes(coefs);
		GUI sgs = new GUI(data);
		sgs.start();
		while ( sgs.alive() ) {}
		return data.result; 
	}
	
	public static void main(String args[]){ 
		try {  // silence System.err (to avoid MadKit printing stuff)
			System.setErr( new java.io.PrintStream( new java.io.FileOutputStream("/dev/null") ) );
		} catch (java.io.FileNotFoundException e) {}  // /dev/null does exist !!!

		final double[] coefs = {.6, .5, .9};
		final double res = eval(coefs); 
		System.out.print("===> "); System.out.println(res);
	}
}
