/*
* RobotEnumerator.java - DynamicBees, a demo for the probe and watcher mechanisms
* Copyright (C) 1998-2002 Olivier Gutknecht, Fabien Michel
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//package dynamicbees;

import java.util.List;
import madkit.kernel.AbstractAgent;
import madkit.kernel.Probe;

/** This probe is used by the environment to know the robots
  @version 2.0
  @author Fabien MICHEL 01/02/2001*/
public class RobotEnumerator extends Probe
{ 
    Environment     robotWorld;
	Robot[] robots = new Robot[0];

    public RobotEnumerator(String group, String role, Environment rw)
    {
    	super("react",group,role);
    	robotWorld = rw;
    }
    
    public void update(AbstractAgent theAgent, boolean added)
    {
    	initialize();
    }
    
    public void initialize()
    {
    	List<?> agentList = getCurrentAgentsList();
    	robots = (Robot[]) agentList.toArray(new Robot[0]);
    	if (robotWorld != null)  robotWorld.updateRobots();
    }
    
    public synchronized Robot[] getRobots()
    {
    	return robots;
    }
 }
