/*
* Scheduler.java - DynamicBees, a demo for the probe and watcher mechanisms
* Copyright (C) 1998-2002 Olivier Gutknecht, Fabien Michel
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//package dynamicbees;

//import madkit.simulation.activators.TurboMethodActivator;
/**
  @version 2.0
  @author Fabien MICHEL 01/02/2001*/
public class Scheduler extends madkit.kernel.Scheduler
{
    // requis pour la sérialisation (!?!), 3* -> envirt
	private static final long serialVersionUID = 31L;

    TurboMethodActivator viewers, robots;
    int delay=30;
    //int iteration = 0;

	public Scheduler() {}
	public Scheduler(int d)  {  delay=d;  }
	public int getDelay() {return delay;}
	public void setDelay(int  v) {this.delay = v;}
	
	public void activate()
	{
	    println("activation");
	    createGroup(false,"react","robots",null,null);
	    requestRole("react","robots","scheduler",null);
	    robots = new TurboMethodActivator("react","react","robots","robot");
	    addActivator(robots);
	    viewers = new TurboMethodActivator("observe","react","robots","robot observer");
	    addActivator(viewers);
	    System.err.println(robots);
	}

  	public void live() {
  		while(true) {
	    	exitImmediatlyOnKill();
			if (delay==0)
			    Thread.yield(); // So we avoid locking other threads on cooperative JVM
			else
			    pause(delay);
			robots.execute();
			viewers.execute();
			//iteration++;
	    }
    } 
    
    public void end()
    {
    	println("stopping simulation ...");
    	disposeMyGUI();
    	super.end();
    }
    	
}
